diff a/test/hotspot/jtreg/runtime/FieldLayout/TestOopMapSizeMinimal.java b/test/hotspot/jtreg/runtime/FieldLayout/TestOopMapSizeMinimal.java
--- a/test/hotspot/jtreg/runtime/FieldLayout/TestOopMapSizeMinimal.java
+++ b/test/hotspot/jtreg/runtime/FieldLayout/TestOopMapSizeMinimal.java
@@ -96,11 +96,11 @@
         } else {
             OOP_SIZE_IN_BYTES = 4;
         }
         if (is_64_bit) {
             if (WB.getBooleanVMFlag("UseCompactObjectHeaders")) {
-                HEADER_SIZE_IN_BYTES = 8;
+                HEADER_SIZE_IN_BYTES = 4;
             } else if (WB.getBooleanVMFlag("UseCompressedClassPointers")) {
                 HEADER_SIZE_IN_BYTES = 12;
             } else {
                 HEADER_SIZE_IN_BYTES = 16;
             }
@@ -192,11 +192,11 @@
         // -UseCompressedOops + +COH, and -UseCompressedOops + -UseCompressedClassPointers.
         // In both cases there is a gap following i1, and i2 will therefore nestle into that gap.
         // Otherwise the same logic applies.
 
         if (OOP_SIZE_IN_BYTES == 4 ||                               // oop size == int size
-            (OOP_SIZE_IN_BYTES == 8 && HEADER_SIZE_IN_BYTES == 12)
+            (OOP_SIZE_IN_BYTES == 8 && (HEADER_SIZE_IN_BYTES == 12 || HEADER_SIZE_IN_BYTES == 4))
         ) {
             // No gaps
 
             // Expected layout for BASE: int, object
             i1_loc_expected = HEADER_SIZE_IN_BYTES;
